D. Exam in MAC - 思维

题面

分析

可以计算出 0 0 0 到 c c c 之间所有的对数,一共有 c + 1 c + 1 c+1 个数,所以有(c + 1) * (c + 2) / 2 对。然后考虑什么情况可以导致出现不符合的情况:

  • 1.可能会存在 x + y x + y x+y 在集合中出现过的,那么对于集合中每一个元素 s i s_i si ,可以得出对于 0 ≤ x ≤ 0 \leq x \leq 0≤x≤ s i 2 {s_i}\over{2} 2si + 1 + 1 +1,每一个数都有另一个范围内的数存在对应,因此这部分都要减去。
  • 2.可能存在 y − x y - x y−x 在集合中出现过的, 那么对于集合中每一个元素 s i s_i si ,可以得出对于 s i ≤ y ≤ c s_i \leq y \leq c si≤y≤c,每一个数都有另一个范围内的数存在对应,因此这部分都要减去。
  • 3.以上两部分减去了一部分重复的,也就是 x + y x + y x+y 和 y − x y - x y−x 同时在集合中的,所以要将这两部分加起来,设 x + y = s i x + y = s_i x+y=si, y − x = s j y - x = s_j y−x=sj,那么解方程可以得到 x x x = s i − s j 2 {s_i - s_j}\over{2} 2si−sj, y y y = s i + s j 2 {s_i + s_j}\over{2} 2si+sj,那么如果 s i 和 s j s_i和s_j si和sj的奇偶性不一样,那么 x 和 y x 和 y x和y就不是整数,说明不存在,其他情况存在。
代码
cpp 复制代码
#include <bits/stdc++.h>

using namespace std;
using ll = long long;

void solve() {
    int n;
    ll c;
    cin >> n >> c;
    vector<ll> x(n);
    for(int i = 0; i < n; i ++) cin >> x[i];
    ll ans = (c + 1) * (c + 2) / 2;
    int cnt1 = 0, cnt2 = 0;
    for(int i = 0; i < n; i ++) {
        ans -= x[i] / 2 + 1;
        ans -= c - x[i] + 1;
        if(x[i] & 1) cnt1 ++;
        else cnt2 ++;
    }
    ans += (ll)cnt1 * (cnt1 + 1) / 2;
    ans += (ll)cnt2 * (cnt2 + 1) / 2;
    cout << ans << "\n";
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int T;
    cin >> T;
    while(T --) {
        solve();
    }
}
相关推荐
apcipot_rain3 小时前
C++转Java日记(04)
java·开发语言·c++
NEFU_Jyj3 小时前
牛客周赛R168
算法
WL学习笔记5 小时前
vector模拟实现
c++
蜗牛一步步往上爬7 小时前
第十六章 C++语言在深度学习中的应用
开发语言·c++·深度学习
Navigator_Z11 小时前
LeetCode //C - 1317. Convert Integer to the Sum of Two No-Zero Integers
c语言·算法·leetcode
wo_jack11 小时前
C++ 入门笔记(十六):第16课 vector 模拟实现十问十答 —— 从三指针到迭代器失效
c++·后端·面试·stl·vector
D e re k ZH11 小时前
C++ 标准库算法全景指南
数据结构·c++·算法
冻柠檬飞冰走茶12 小时前
字母移动游戏题解:贪心求最长可保留连续子串(附 C 实现)
c语言·开发语言·数据结构·算法·动态规划
雪落漂泊13 小时前
C++算法 二分查找篇(上)
开发语言·c++·算法